/**
 * Based on examples in
 *     Head First Object-Oriented Analysis and Design
 *     by Brett D. McLaughlin, Gary Pollice, and David West
 *     O'Reilly, 2007
 *     ISBN 978-0-596-00867-3
 *
 * Ported from Java by
 *     Ronald Mak
 *     Department of Computer Engineering
 *     San Jose State University
 *     San Jose, CA  95192
 */
#ifndef INVENTORY_H_
#define INVENTORY_H_

#include <vector>
#include "Guitar.h"
#include "Builder.h"
#include "Type.h"
#include "Wood.h"

using namespace std;

class Inventory
{
public:
    Inventory() {}

    void add_guitar(string serial_number, double price,
                    Builder builder, string model, Type type,
                    Wood back_wood, Wood top_wood);

    Guitar *get_guitar(string serial_number) const;
    vector<Guitar *> search(Guitar *ideal_guitar);

private:
    vector<Guitar *> guitars;

    string to_lower(string str);
};

inline string Inventory::to_lower(string str)
{
    transform(str.begin(), str.end(), str.begin(), ::tolower);
    return str;
}

#endif /* INVENTORY_H_ */
